## dos2unix 6.0.3

=== debian/changelog ===
dos2unix (6.0.3-1) unstable; urgency=low

  * New upstream release.
    - Support compiling with Microsoft Visual C.
    - Display an error message if writing output fails.
  * debian/control
    - (Standards-Version): Update to 3.9.4.
  * debian/copyright
    - Update current year.

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 26 Jan 2013 09:15:45 +0200

dos2unix (6.0.2-1) unstable; urgency=low

  * New upstream release.
    - The locale encoding detection has been fixed when NLS was disabled.
    - Display line number when a binary symbol is found.
    - Update makefiles for Watcom C, and added a new one for OS/2.
  * debian/clean
    - Drop wildcard from dos2unix.htm*, drop Spanish man/es/* line.
  * debian/compat
    - Update to 9.
  * debian/docs
     - Clean up for current release.
  * debian/control
    - (Build-Depends): Add dpkg-dev for hardened flags.
      Update to debhelper 9.
  * debian/copyright
    - Update to Format 1.0
  * debian/rules
    - Use hardened build flags
      http://wiki.debian.org/ReleaseGoals/SecurityHardeningBuildFlags
    - (dh_installdocs): Remove. Not needed after debian/docs clean up.
  * debian/watch
    - Remove extra comment.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 14 Sep 2012 07:12:23 +0300

=== debian/control ===
Source: dos2unix
Section: text
Priority: extra
Maintainer: Jari Aalto <jari.aalto@cante.net>
Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 9)
Standards-Version: 3.9.4
Vcs-Browser: http://git.debian.org/?p=collab-maint/dos2unix.git
Vcs-Git: git://git.debian.org/git/collab-maint/dos2unix.git
Homepage: http://freshmeat.net/projects/dos2unix

Package: dos2unix
Conflicts: tofrodos (<< 1.7.8.debian.1)
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: convert text file line endings between CRLF and LF
 This package contains utilities dos2unix, unix2dos, mac2unix,
 unix2mac to convert the line endings of text files between UNIX (LF),
 DOS (CRLF) and Mac (CR) formats.
 .
 Text files under Windows and DOS typically have two ASCII characters
 at the end of each line: CR (carriage return) followed by LF (line
 feed). Older Macs used just CR, while UNIX uses just LF. While most
 modern editors can read all these formats, there may still be a need
 to convert files between them.
 .
 This is the classic utility developed in 1989.

## dos2unix 6.0.4

=== Makefile ===
# Author: Erwin Waterlander
#
#   Copyright (C) 2009-2013 Erwin Waterlander
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice in the documentation and/or other materials provided with
#      the distribution.
#
#   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
#   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
#   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
#   OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
#   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
#   OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
#   IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#   Description
#
#	This is a GNU Makefile that uses GNU compilers, linkers and cpp. The
#	platform specific issues are determined by the various OS teets that
#	rely on the uname(1) command and directory locations.
#
#	Set additional flags for the build with variables CFLAGS_USER,
#	DEFS_USER and LDFLAGS_USER.

include version.mk

.PHONY: man txt html pdf mofiles tags merge

CC		?= gcc
CPP		?= cpp
CPP_FLAGS_POD	= ALL
STRIP		= strip

PACKAGE		= dos2unix
UNIX2DOS	= unix2dos
MAC2UNIX	= mac2unix
UNIX2MAC	= unix2mac

# Native Language Support (NLS)
ENABLE_NLS	= 1
# Large File Support (LFS)
LFS             = 1
DEBUG = 0
UCS = 1
# I can set MAN_NONLATIN to 1, despite the compilation issues with old Perl
# versions, because I'm going to include the non-Latin1 manual files into the
# source package.
MAN_NONLATIN = 1

EXE=

BIN		= $(PACKAGE)$(EXE)
UNIX2DOS_BIN	= $(UNIX2DOS)$(EXE)
MAC2UNIX_BIN	= $(MAC2UNIX)$(EXE)
UNIX2MAC_BIN	= $(UNIX2MAC)$(EXE)

# DJGPP support linking of .EXEs via 'stubify'.
# See djgpp.mak and http://www.delorie.com/djgpp/v2faq/faq22_5.html

LINK		= ln -sf
LINK_MAN	= $(LINK)

prefix		= /usr
exec_prefix	= $(prefix)
bindir		= $(exec_prefix)/bin
datarootdir	= $(prefix)/share
datadir		= $(datarootdir)

docsubdir	= $(PACKAGE)-$(DOS2UNIX_VERSION)
docdir		= $(datarootdir)/doc/$(docsubdir)
localedir	= $(datarootdir)/locale
mandir		= $(datarootdir)/man
man1dir		= $(mandir)/man1
manext		= .1
man1ext		= .1

ifdef ENABLE_NLS
	POT		= po/$(PACKAGE).pot
	POFILES		= $(wildcard po/??.po)
	MOFILES		= $(patsubst %.po,%.mo,$(POFILES))
	EOX_POFILES	= po/eo-x.po
	NLSSUFFIX       = -nls
endif

HTMLEXT = htm
# By default we generate only English text and html manuals.
# Then we don't need "pod2text --utf8" and we have no dependency on iconv.
DOCFILES	= man/man1/$(PACKAGE).txt man/man1/$(PACKAGE).$(HTMLEXT)
INSTALL_OBJS_DOC = README.txt INSTALL.txt NEWS.txt ChangeLog.txt COPYING.txt TODO.txt BUGS.txt $(DOCFILES)

PODFILES_ALL	= man/man1/dos2unix.pod $(wildcard man/*/man1/dos2unix.pod)
PODFILES	= $(wildcard man/*/man1/dos2unix.pod)
MANFILES	= $(patsubst %.pod,%.1,$(PODFILES))
TXTFILES	= $(patsubst %.pod,%.txt,$(PODFILES_ALL))
HTMLFILES	= $(patsubst %.pod,%.$(HTMLEXT),$(PODFILES_ALL))
PSFILES 	= $(patsubst %.pod,%.ps,$(PODFILES_ALL))
PDFFILES	= $(patsubst %.pod,%.pdf,$(PODFILES_ALL))
UTF8FILES	= $(patsubst %.pod,%.ut8,$(PODFILES_ALL))

# On some systems (e.g. FreeBSD 4.10) GNU install is installed as `ginstall'.
INSTALL		= install

# On some systems (e.g. GNU Win32) GNU mkdir is installed as `gmkdir'.
MKDIR           = mkdir

ifdef ENABLE_NLS
	DOS2UNIX_NLSDEFS = -DENABLE_NLS -DLOCALEDIR=\"$(localedir)\" -DPACKAGE=\"$(PACKAGE)\"
endif

VERSIONSUFFIX	= -bin

# ......................................................... OS flags ...

D2U_OS =

ifndef D2U_OS
ifeq (Linux, $(shell uname -s))
	D2U_OS = linux
endif
endif

ifndef D2U_OS
ifeq ($(findstring CYGWIN,$(shell uname)),CYGWIN)
	D2U_OS = cygwin
endif
endif

ifeq (cygwin,$(D2U_OS))
ifdef ENABLE_NLS
	LIBS_EXTRA = -lintl -liconv
endif
	LDFLAGS_EXTRA = -Wl,--enable-auto-import
	EXE = .exe
	# allow non-cygwin clients which do not understand cygwin
	# symbolic links to launch applications...
	LINK = ln -f
	# but use symbolic links for man pages, since man client
	# IS a cygwin app and DOES understand symlinks.
	LINK_MAN = ln -fs
	# Cygwin packaging standard avoids version numbers on
	# documentation directories.
	docsubdir	= $(PACKAGE)
	VERSIONSUFFIX	= -cygwin
	MAN_NONLATIN = 1
endif

ifndef D2U_OS
ifeq ($(findstring MSYS,$(shell uname)),MSYS)
	CC=gcc
	D2U_OS = msys
	EXE = .exe
	VERSIONSUFFIX	= -msys
	EO_XNOTATION=1
	UCS =
	MAN_NONLATIN =
ifdef ENABLE_NLS
	LIBS_EXTRA = -lintl -liconv
endif
endif
endif

ifndef D2U_OS
ifeq ($(findstring MINGW32,$(shell uname)),MINGW32)
	D2U_OS = mingw32
	prefix=c:/usr/local
	EXE = .exe
	VERSIONSUFFIX	= -win32
	LINK = cp -f
	EO_XNOTATION=1
	MAN_NONLATIN =
ifdef ENABLE_NLS
	LIBS_EXTRA = -lintl -liconv
	ZIPOBJ_EXTRA = bin/libintl-8.dll bin/libiconv-2.dll
endif
ifeq ($(findstring w64-mingw32,$(shell gcc -dumpmachine)),w64-mingw32)
	CFLAGS_COMPILER = -DD2U_COMPILER=MINGW32_W64
endif
endif
endif

ifndef D2U_OS
ifneq ($(DJGPP),)
	D2U_OS = msdos
	prefix=c:/dos32
	EXE = .exe
	VERSIONSUFFIX = pm
	LINK_MAN = cp -f
	docsubdir = dos2unix
	EO_XNOTATION=1
	UCS =
	MAN_NONLATIN =
	ZIPOBJ_EXTRA = bin/cwsdpmi.exe
ifdef ENABLE_NLS
	LIBS_EXTRA = -lintl -liconv
endif
endif
endif

ifndef D2U_OS
ifeq ($(shell uname),OS/2)
	D2U_OS = os/2
	prefix=c:/usr
	EXE = .exe
	VERSIONSUFFIX = -os2
	LINK_MAN = cp -f
	EO_XNOTATION=1
	UCS =
	MAN_NONLATIN =
	LDFLAGS_EXTRA = -Zargs-wild
ifdef ENABLE_NLS
	LIBS_EXTRA += -lintl -liconv
endif
endif
endif

ifndef D2U_OS
ifeq (FreeBSD, $(shell uname -s))
	D2U_OS = freebsd
ifdef ENABLE_NLS
	CFLAGS_OS     = -I/usr/local/include
	LDFLAGS_EXTRA = -L/usr/local/lib
	LIBS_EXTRA    = -lintl
endif
endif
endif

ifeq (Darwin, $(shell uname -s))
	D2U_OS = Darwin
ifdef ENABLE_NLS
	CFLAGS_OS     = -I/usr/local/include
	LDFLAGS_EXTRA = -L/usr/local/lib
	LIBS_EXTRA    = -lintl
endif
endif


ifndef D2U_OS
ifneq (, $(wildcard /opt/csw))
	D2U_OS = sun
endif
endif

ifeq (sun,$(D2U_OS))
	# Running under SunOS/Solaris
	LIBS_EXTRA = -lintl
endif

ifndef D2U_OS
ifeq (HP-UX, $(shell uname -s))
	D2U_OS = hpux
endif
endif

ifeq (hpux,$(D2U_OS))
	# Running under HP-UX
	EXTRA_DEFS += -Dhpux -D_HPUX_SOURCE
endif

ifndef D2U_OS
	D2U_OS = $(shell uname -s)
endif

# ............................................................ flags ...

# For systems that don't support Unicode or Latin-3, select
# Esperanto in X-notation format: EO_XNOTATION=1

ifdef EO_XNOTATION
EO_NOTATION = -x
endif

ifeq ($(MAN_NONLATIN),1)
PODFILES_NONLATIN  = $(wildcard man/nonlatin/*/man1/dos2unix.pod)
MANFILES_NONLATIN  = $(patsubst %.pod,%.1,$(PODFILES_NONLATIN))
TXTFILES_NONLATIN  = $(patsubst %.pod,%.txt,$(PODFILES_NONLATIN))
HTMLFILES_NONLATIN = $(patsubst %.pod,%.$(HTMLEXT),$(PODFILES_NONLATIN))
# PostScript and PDF generation from UTF-8 manuals is not working,
# or I don't know how to do it.
#PSFILES_NONLATIN   = $(patsubst %.pod,%.ps,$(PODFILES_NONLATIN))
#PDFFILES_NONLATIN  = $(patsubst %.pod,%.pdf,$(PODFILES_NONLATIN))
endif

CFLAGS_USER	=
CFLAGS		?= -O2
CFLAGS		+= -Wall $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)

EXTRA_CFLAGS	= -DVER_REVISION=\"$(DOS2UNIX_VERSION)\" \
		  -DVER_DATE=\"$(DOS2UNIX_DATE)\" \
		  -DVER_AUTHOR=\"$(DOS2UNIX_AUTHOR)\" \
		  -DDEBUG=$(DEBUG) \
		  $(CFLAGS_OS) \
		  $(CFLAGS_COMPILER)

ifeq ($(DEBUG), 1)
	EXTRA_CFLAGS += -g
endif

ifdef STATIC
	EXTRA_CFLAGS += -static
endif

ifdef UCS
	EXTRA_CFLAGS += -DD2U_UNICODE
endif

ifdef LFS
	EXTRA_CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
endif

LDFLAGS_USER	=
LDFLAGS = $(RPM_OPT_FLAGS) $(LDFLAGS_EXTRA) $(LDFLAGS_USER)
LIBS    = $(LIBS_EXTRA)

DEFS_USER	=
DEFS		= $(EXTRA_DEFS) $(DEFS_USER)

# .......................................................... targets ...

all: $(BIN) $(MAC2UNIX_BIN) $(UNIX2DOS_BIN) $(UNIX2MAC_BIN) $(DOCFILES) $(MOFILES) $(EOX_POFILES) man/man1/dos2unix.1 $(MANFILES) $(MANFILES_NONLATIN)

status:
	@echo "D2U_OS       = $(D2U_OS)"
	@echo "UCS          = $(UCS)"
	@echo "CFLAGS       = $(CFLAGS)"
	@echo "EXTRA_CFLAGS = $(EXTRA_CFLAGS)"
	@echo "LDFLAGS      = $(LDFLAGS)"
	@echo "LIBS         = $(LIBS)"

common.o : common.c common.h
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

querycp.o : querycp.c querycp.h
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

dos2unix.o : dos2unix.c dos2unix.h querycp.h common.h version.mk
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

unix2dos.o : unix2dos.c unix2dos.h querycp.h common.h version.mk
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

$(BIN): dos2unix.o querycp.o common.o
	$(CC) $+ $(LDFLAGS) $(LIBS) -o $@

$(UNIX2DOS_BIN): unix2dos.o querycp.o common.o
	$(CC) $+ $(LDFLAGS) $(LIBS) -o $@

$(MAC2UNIX_BIN) : $(BIN)
	$(LINK) $< $@

%.1 : %.pod
	$(MAKE) -C man/man1 MAN_NONLATIN=$(MAN_NONLATIN)

$(UNIX2MAC_BIN) : $(UNIX2DOS_BIN)
	$(LINK) $< $@

mofiles: $(MOFILES)

html: $(HTMLFILES) $(HTMLFILES_NONLATIN)

txt: $(TXTFILES) $(TXTFILES_NONLATIN)

ps: $(PSFILES) $(PSFILES_NONLATIN)

pdf: $(PDFFILES) $(PDFFILES_NONLATIN)

man: man/man1/dos2unix.1 $(MANFILES) $(MANFILES_NONLATIN)

doc: $(DOCFILES)

tags: $(POT)

merge: $(POFILES) $(EOX_POFILES)

po/%.po : $(POT)
	msgmerge -U $@ $(POT) --backup=numbered
	# change timestamp in case .po file was not updated.
	touch $@

%.mo : %.po
	msgfmt -c $< -o $@

po/eo.mo : po/eo$(EO_NOTATION).po
	msgfmt -c $< -o $@

$(POT) : dos2unix.c unix2dos.c common.c
	xgettext -C --keyword=_ $+ -o $(POT)

# Convert text files to UTF-8. Notepad has no problem with UTF-8.
# Use iconv to convert to UTF-8. There are many old pod2text versions
# around that don't have the --utf8 option yet.
%.tx1 : %.pod
	pod2text $< > $@

%.txt : %.tx1
	iconv -f ISO-8859-1 -t UTF-8 $< > $@

# Create the English txt manual straight from the .pod file. It contains only ASCII.
# This saves a dependency on iconv.
man/man1/$(PACKAGE).txt : man/man1/$(PACKAGE).pod
	pod2text $< > $@

# Non-Latin1 script manuals are already in UTF-8 format.
man/nonlatin/ru/man1/$(PACKAGE).txt : man/nonlatin/ru/man1/$(PACKAGE).pod
	pod2text $< > $@

%.ps : %.1
	groff -man $< -T ps > $@

%.pdf: %.ps
	ps2pdf $< $@

# The POD files are encoded in Latin-1. See also man/man1/Makefile
# For non-English HTML it is best to use UTF-8.
%.ut8 : %.pod
	iconv -f ISO-8859-1 -t UTF-8 $< > $@

# Generic rule.
%.$(HTMLEXT) : %.ut8
	pod2html --title="$(PACKAGE) $(DOS2UNIX_VERSION) - DOS/MAC to UNIX and vice versa text file format converter" $< > $@

# Create the English html manual straight from the .pod file. It contains only ASCII.
# This saves a dependency on iconv.
man/man1/$(PACKAGE).$(HTMLEXT) : man/man1/$(PACKAGE).pod
	pod2html --title="$(PACKAGE) $(DOS2UNIX_VERSION) - DOS/MAC to UNIX and vice versa text file format converter" $< > $@

man/nl/man1/$(PACKAGE).$(HTMLEXT) : man/nl/man1/$(PACKAGE).ut8
	pod2html --title="$(PACKAGE) $(DOS2UNIX_VERSION) - DOS/Mac naar Unix en vice versa tekstbestand formaat omzetter" $< > $@

man/es/man1/$(PACKAGE).$(HTMLEXT) : man/es/man1/$(PACKAGE).ut8
	pod2html --title="$(PACKAGE) $(DOS2UNIX_VERSION) - Convertidor de archivos de texto de formato DOS/Mac a Unix y viceversa" $< > $@

man/nonlatin/ru/man1/$(PACKAGE).$(HTMLEXT) : man/nonlatin/ru/man1/$(PACKAGE).pod
	pod2html --title="$(PACKAGE) $(DOS2UNIX_VERSION) - DOS/MAC to UNIX and vice versa text file format converter" $< > $@

install: all
	$(MKDIR) -p -m 755 $(DESTDIR)$(bindir)
	$(INSTALL)  -m 755 $(BIN) $(DESTDIR)$(bindir)
	$(INSTALL)  -m 755 $(UNIX2DOS_BIN) $(DESTDIR)$(bindir)

=== man/man1/Makefile ===
# pod2man.mk -- Makefile portion to convert *.pod files to manual pages
#
#   Copyright information
#
#	Copyright (C) 2010 Jari Aalto
#
#   License
#
#	Redistribution and use in source and binary forms, with or
#	without modification, are permitted provided that the
#	following conditions are met:
#
#	1. Redistributions of source code must retain the above
#	   copyright notice, this list of conditions and the following
#	   disclaimer.
#
#	2. Redistributions in binary form must reproduce the above
#	   copyright notice, this list of conditions and the following
#	   disclaimer in the documentation and/or other materials
#	   provided with the distribution.
#
#	THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR
#	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
#	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR(S) OF THIS
#	FILE OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
#	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
#	GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#	NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
#	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
#	DAMAGE.
#
#	The license text is copy of the FreeBSD License available at
#	<http://www.gnu.org/copyleft/gpl.html> with following
#	modifications: wording "THIS SOFTWARE IS PROVIDED BY THE
#	FREEBSD PROJECT" was changed to "THIS SOFTWARE IS PROVIDED 'AS
#	IS'" and wording "IN NO EVENT SHALL THE FREEBSD PROJECT" was
#	changed to "IN NO EVENT SHALL THE AUTHOR(S)"
#
#   Description
#
# 	Convert *.pod files to manual pages.

ifneq (,)
    This makefile requires GNU Make.
endif

# This variable *must* be set when calling
PACKAGE		?= dos2unix

# Optional variables to set
MANSECT		?= 1
PODCENTER	?= $$(date "+%Y-%m-%d")

# Directories
MANSRC		=
MANDEST		= $(MANSRC)

MANPOD		= $(MANSRC)$(PACKAGE).pod
MANPAGE		= $(MANDEST)$(PACKAGE).$(MANSECT)

POD2MAN		= pod2man
POD2MAN_FLAGS	=
MAN_NONLATIN    ?= 1

PODFILES = $(wildcard ../*/man1/dos2unix.pod)
MAN_OBJECTS = dos2unix.1 $(patsubst %.pod,%.1,$(PODFILES))
ifeq ($(MAN_NONLATIN),1)
PODFILES_NONLATIN = $(wildcard ../nonlatin/*/man1/dos2unix.pod)
MAN_OBJECTS_NONLATIN = dos2unix.1 $(patsubst %.pod,%.1,$(PODFILES_NONLATIN))
endif

all: $(MAN_OBJECTS) $(MAN_OBJECTS_NONLATIN)

MAN_OBJECTS_NONLATIN = $(patsubst %.pod,%.1,$(PODFILES_NONLATIN))

# The .pod files for Latin scripts are encoded in Latin-1 (ISO-8859-1/CP1252).
# UTF-8 man pages are not properly displayed in a Windows Command Prompt,
# therefore we keep them in Latin-1 format.

# Cygwin 1.7 expects man pages to be in Latin-1 format.

# The perl version of MinGW and DJGPP is 5.8.8. The pod2man command of perl
# 5.8.8 does not yet have the options -u, --utf8, and does support the =encoding
# command.

# There are different *roff implementations. For now I assume we are using
# groff (GNU-roff) which is wide spread, default on Linux, Cygwin, MinGW, and
# DJGPP.  The groff specific escape sequences may not work with other *roff
# implementations, but they display OK when used in a Windows Command Prompt
# using DJGPP's or MinGW's groff. Although sometimes characters are displayed
# without their diacritics.

# One day everything will be in UTF-8...
# For the English manual it all makes no difference, because the English text
# is plain ASCII.

%.1 : %.pod
	# make target - create manual page from a *.pod page
	podchecker $<
	LC_CTYPE=C $(POD2MAN) $(POD2MAN_FLAGS) \
		--center="$(PODCENTER)" \
		--name="$(PACKAGE)" \
		--section="$(MANSECT)" \
		$< \
	| perl -p -e 's/[Pp]erl v[0-9.]+/$(PACKAGE)/;' \
	  > $@ && \
	rm -f pod*.tmp
# fix for bug http://rt.perl.org/rt3//Public/Bug/Display.html?id=79410
# "Pod2man creates wrong ROFF esc sequences for Latin-1 characters."
# Create groff (specific) escape sequences which work also on DOS/Windows.
# See also: https://rt.cpan.org/Public/Bug/Display.html?id=73804
	perl -pli.bak \
		-e s/A\\\\\\*\'/\\\\[\'A]/g\; \
		-e s/a\\\\\\*\'/\\\\[\'a]/g\; \
		-e s/E\\\\\\*\'/\\\\[\'E]/g\; \
		-e s/e\\\\\\*:/\\\\[:e]/g\; \
		-e s/e\\\\\\*\'/\\\\[\'e]/g\; \
		-e s/i\\\\\\*\'/\\\\[\'i]/g\; \
		-e s/n\\\\\\*~/\\\\[~n]/g\; \
		-e s/O\\\\\\*\'/\\\\[\'O]/g\; \
		-e s/o\\\\\\*\'/\\\\[\'o]/g\; \
		-e s/u\\\\\\*\'/\\\\[\'u]/g\; \
		$@



# The .pod files under the 'nonlatin' folder are encoded in UTF-8.
# For these manuals pod2man needs to support the =encoding command
# and the --utf8 option. This is supported since perl 5.10.1.
# Erwin W.

nonlatin: $(MAN_OBJECTS_NONLATIN)


../nonlatin/ru/%.1 : ../nonlatin/ru/%.pod
	# make target - create manual page from a *.pod page
	podchecker $<
	$(POD2MAN) $(POD2MAN_FLAGS) \
                --utf8 \
		--center="$(PODCENTER)" \
		--name="$(PACKAGE)" \
		--section="$(MANSECT)" \
		$< \
	| perl -p -e 's/[Pp]erl v[0-9.]+/$(PACKAGE)/;' \
	  > $@ && \
	rm -f pod*.tmp

clean:
	rm -f $(MAN_OBJECTS)
	rm -f $(MAN_OBJECTS_NONLATIN)

# End of of Makefile part

=== debian/changelog ===
dos2unix (6.0.4-1) unstable; urgency=low

  * New upstream release.
    - GPG signed source package
  * debian/control
    - (Standards-Version): Update to 3.9.5.
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/source/include-binaries
    - New.
  * debian/upstream-signing-key.pgp
    - New.
  * debian/watch
    - (pgpsigurlmangle): Add.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 03 Jan 2014 13:05:44 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: extra
 Maintainer: Jari Aalto <jari.aalto@cante.net>
 Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 9)
-Standards-Version: 3.9.4
-Vcs-Browser: http://git.debian.org/?p=collab-maint/dos2unix.git
-Vcs-Git: git://git.debian.org/git/collab-maint/dos2unix.git
+Standards-Version: 3.9.5
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/dos2unix.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/dos2unix.git
 Homepage: http://freshmeat.net/projects/dos2unix
 
 Package: dos2unix

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE         = dos2unix
PKGDIR		= $(CURDIR)/debian/$(PACKAGE)
DOCROOTDIR      = $(PKGDIR)/usr/share/doc
PKGDOCDIR       = $(DOCROOTDIR)/$(PACKAGE)

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# From dpkg-dev
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(MAKE) LDFLAGS_USER="$(LDFLAGS)" CFLAGS_USER="$(CPPFLAGS) $(CFLAGS)"

override_dh_clean:
	dh_clean
	rm -f man/es/man1/dos2unix.1

override_dh_auto_install:
	dh_auto_install

	# dos2unix-N.N/ => dos2unix/
	mv -v $(DOCROOTDIR)/$$( cd $(DOCROOTDIR) && ls ) $(PKGDOCDIR)

	# Remove files that are not needed. The PS and PDF are
	# copies of manual pages.

	rm -vf $(PKGDOCDIR)/COPYING.txt \
	       $(PKGDOCDIR)/INSTALL.txt \
	       $(PKGDOCDIR)/ChangeLog.txt \

%:
	dh $@

# End of file

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
http://www.xs4all.nl/~waterlan/dos2unix.html .*dos2unix-([.\d]+)\.tar\.gz

## dos2unix 7.3.4

=== test/Makefile ===
TESTS = ascii.t iso.t utf8.t misc.t

d2u_os=$(shell uname -s)
UCS = 1

# Checking WIN32 version in MSYS shell.
ifeq ($(findstring MINGW,$(d2u_os)),MINGW)
TESTS += gb18030.t
endif

ifneq ($(findstring FreeBSD,$(d2u_os)),FreeBSD)
# Unix/Linux/Cygwin. Check if zh_CN.gb18030 locale is supported.
ifeq ($(shell ./chk_loc.sh zh_CN.gb18030),yes)
TESTS += gb18030.t
endif
endif

# DOS and Windows version do not support symlinks like the Unix version.
ifeq ($(DJGPP),)
ifneq ($(findstring MINGW,$(d2u_os)),MINGW)
TESTS += symlink.t
endif
endif

ifeq ($(UCS),1)
TESTS +=utf16.t
endif


all: test

check: test

test:
	prove -v $(TESTS)


ascii:
	prove -v $@.t

iso:
	prove -v $@.t

misc:
	prove -v $@.t

utf8:
	prove -v $@.t

utf16:
	prove -v $@.t

gb18030:
	prove -v $@.t

symlink:
	prove -v $@.t

wcstombs:
	$(CC) -Wall -Wextra wcstombs_test.c -o wcstombs_test
	@echo "====> test wcstombs() UTF-8"
	LC_ALL=en_US.UTF-8 ./wcstombs_test
	@echo "====> test wcstombs() GB18030"
	LC_ALL=zh_CN.GB18030 ./wcstombs_test

testu16: testu16.c
	gcc $< -o $@

clean:
	rm -f out*.txt in_link.txt wcstombs_test

=== man/man1/Makefile ===
# pod2man.mk -- Makefile portion to convert *.pod files to manual pages
#
#   Copyright information
#
#	Copyright (C) 2010 Jari Aalto
#	Copyright (C) 2010-2016 Erwin Waterlander
#
#   License
#
#	Redistribution and use in source and binary forms, with or
#	without modification, are permitted provided that the
#	following conditions are met:
#
#	1. Redistributions of source code must retain the above
#	   copyright notice, this list of conditions and the following
#	   disclaimer.
#
#	2. Redistributions in binary form must reproduce the above
#	   copyright notice, this list of conditions and the following
#	   disclaimer in the documentation and/or other materials
#	   provided with the distribution.
#
#	THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR
#	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
#	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR(S) OF THIS
#	FILE OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
#	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
#	GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#	NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
#	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
#	DAMAGE.
#
#	The license text is copy of the FreeBSD License available at
#	<http://www.gnu.org/copyleft/gpl.html> with following
#	modifications: wording "THIS SOFTWARE IS PROVIDED BY THE
#	FREEBSD PROJECT" was changed to "THIS SOFTWARE IS PROVIDED 'AS
#	IS'" and wording "IN NO EVENT SHALL THE FREEBSD PROJECT" was
#	changed to "IN NO EVENT SHALL THE AUTHOR(S)"
#
#   Description
#
# 	Convert *.pod files to manual pages.

ifneq (,)
    This makefile requires GNU Make.
endif

.PRECIOUS: %.pod

# This variable *must* be set when calling
PACKAGE		?= dos2unix

# Optional variables to set
MANSECT		?= 1
PODCENTER	?= $$(date "+%Y-%m-%d")

# Directories
MANSRC		=
MANDEST		= $(MANSRC)

MANPOD		= $(MANSRC)$(PACKAGE).pod
MANPAGE		= $(MANDEST)$(PACKAGE).$(MANSECT)

POD2MAN		= pod2man
POD2MAN_FLAGS	=

POFILES = $(wildcard ../../po-man/*.po)
PODFILES = $(patsubst ../../po-man/%.po,../%/man1/dos2unix.pod,$(POFILES))
MAN_OBJECTS = dos2unix.1 $(patsubst %.pod,%.1,$(PODFILES))

MKDIR = mkdir

all: $(MAN_OBJECTS) ../../po-man/dos2unix-man.pot

# Issues:

# The perl version of MinGW and DJGPP is 5.8.8. The pod2man command of perl
# 5.8.8 does not yet have the options -u, --utf8, and does support the
# =encoding command.  The =encoding command and the --utf8 option are supported
# since perl 5.10.1.
# Erwin W.

# Dos2unix 6.0.5: Forget Latin-1, we do now only UTF-8.

../../po-man/dos2unix-man.pot : dos2unix.pod
	po4a-updatepo -f pod -m $< -p $@ --msgmerge-opt --no-wrap

%.po : dos2unix.pod
	po4a-updatepo -f pod -m $< -p $@ --msgmerge-opt "--backup=numbered --no-wrap"
	# change timestamp in case .po file was not updated.
	touch $@

# Create pod files from po.
# Fix problem that =encoding is before =pod command.
../%/man1/dos2unix.pod : ../../po-man/%.po
	$(MKDIR) -p $(dir $@)
	po4a-translate -f pod -m dos2unix.pod -k 70 -p $< > $@
	perl -ni.bak -e 'print unless /=encoding UTF-8/' $@
	perl -pli.bak -e 's/=pod/=pod\n\n=encoding UTF-8/' $@

# An empty recipe for dos2unix.pod to break circular dependency.
dos2unix.pod : ;

%.1 : %.pod
	# make target - create manual page from a *.pod page
	podchecker $<
	$(POD2MAN) $(POD2MAN_FLAGS) \
		--utf8 \
		--center="$(PODCENTER)" \
		--name="$(PACKAGE)" \
		--section="$(MANSECT)" \
		$< \
	| perl -p -e 's/[Pp]erl v[0-9.]+/$(PACKAGE)/;' \
	  > $@ && \
	rm -f pod*.tmp



clean:
	rm -f $(MAN_OBJECTS)
	rm -f ../../po-man/dos2unix-man.pot
	rm -f $(PODFILES)

# End of of Makefile part

=== debian/changelog ===
dos2unix (7.3.4-3) unstable; urgency=medium

  * debian/control
    - (Multi-Arch): foreign (Closes: #843907). Patch
      thanks to Helmut Grohne <helmut@subdivi.de>.
  * debian/copyright
    - Update URLs.
  * debian/rules
    - Use dh_auto_build(1) instead of make(1) to enable cross building
      (Closes: #843923). Patch thanks to Helmut Grohne
      <helmut@subdivi.de>.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 11 Nov 2016 06:13:44 +0200

dos2unix (7.3.4-2) unstable; urgency=medium

  * debian/control
    - (Build-Depends): Add locales-all. (Closes: #842053)
  * debian/rules
    - (overide_dh_auto_test): Drop adjustment for pbuilder.

 -- tony mancill <tmancill@debian.org>  Tue, 25 Oct 2016 21:36:02 -0700

dos2unix (7.3.4-1) unstable; urgency=medium

  * New upstream release (Closes: 785115).
  * debian/control
    - (Build-Depends): Add po4a.
    - (Homepage): Update URL.
    - (Standards-Version): Update to 3.9.8.
    - (Vcs-*): Update to anonscm.debian.org.
  * debian/copyright
    - (Source): Update URLs.
  * debian/rules
    - (overide_dh_auto_test): Add adjustment for pbuilder.
  * debian/sources/options
    - New file.

 -- Jari Aalto <jari.aalto@cante.net>  Mon, 24 Oct 2016 20:51:11 +0300

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,17 @@
 Section: text
 Priority: extra
 Maintainer: Jari Aalto <jari.aalto@cante.net>
-Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 9)
-Standards-Version: 3.9.5
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/dos2unix.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/dos2unix.git
-Homepage: http://freshmeat.net/projects/dos2unix
+Uploaders: tony mancill <tmancill@debian.org>
+Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 9), po4a, locales-all
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/dos2unix.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/dos2unix.git
+Homepage: https://waterlan.home.xs4all.nl/dos2unix.html
 
 Package: dos2unix
 Conflicts: tofrodos (<< 1.7.8.debian.1)
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: convert text file line endings between CRLF and LF
  This package contains utilities dos2unix, unix2dos, mac2unix,

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 PKGDIR		= $(CURDIR)/debian/$(PACKAGE)
 DOCROOTDIR      = $(PKGDIR)/usr/share/doc
 PKGDOCDIR       = $(DOCROOTDIR)/$(PACKAGE)
+
+BUILD_DATE   = $(shell dpkg-parsechangelog -S Date)
+PODCENTER    = $(shell date -u +"%Y-%m-%d" --date="$(BUILD_DATE)")
+export PODCENTER
 
 export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
@@ -14,7 +18,8 @@
 include /usr/share/dpkg/buildflags.mk
 
 override_dh_auto_build:
-	$(MAKE) LDFLAGS_USER="$(LDFLAGS)" CFLAGS_USER="$(CPPFLAGS) $(CFLAGS)"
+	env LANG=en_US.UTF-8 \
+	dh_auto_build -- LDFLAGS_USER="$(LDFLAGS)" CFLAGS_USER="$(CPPFLAGS) $(CFLAGS)"
 
 override_dh_clean:
 	dh_clean

## dos2unix 7.4.0

=== Makefile ===
# Author: Erwin Waterlander
#
#   Copyright (C) 2009-2017 Erwin Waterlander
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice in the documentation and/or other materials provided with
#      the distribution.
#
#   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
#   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
#   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
#   OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
#   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
#   OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
#   IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#   Description
#
#       This is a GNU Makefile that uses GNU compilers, linkers and cpp. The
#       platform specific issues are determined by the various OS teets that
#       rely on the uname(1) command and directory locations.
#
#       Set additional flags for the build with variables CFLAGS_USER,
#       DEFS_USER and LDFLAGS_USER.

include version.mk

.PHONY: doc man txt html pdf mofiles tags merge test check

.PRECIOUS: %.1 %.pod

CC              ?= gcc
CPP             ?= cpp
CPP_FLAGS_POD   = ALL
STRIP           = strip

PACKAGE         = dos2unix
UNIX2DOS        = unix2dos
MAC2UNIX        = mac2unix
UNIX2MAC        = unix2mac

# Native Language Support (NLS)
ENABLE_NLS      = 1
# Large File Support (LFS)
LFS             = 1
# DEBUG=1 adds the -g option to CFLAGS, for adding debug symbols.
DEBUG = 0
# DEBUGMSG=1 adds -DDEBUG=1 to CFLAGS, for extra verbose messages.
DEBUGMSG = 0
UCS = 1
DIST_TARGET = dist-tgz

EXE=

BIN             = $(PACKAGE)$(EXE)
UNIX2DOS_BIN    = $(UNIX2DOS)$(EXE)
MAC2UNIX_BIN    = $(MAC2UNIX)$(EXE)
UNIX2MAC_BIN    = $(UNIX2MAC)$(EXE)

LINK            = ln -sf
LINK_MAN        = $(LINK)

prefix          = /usr
exec_prefix     = $(prefix)
bindir          = $(exec_prefix)/bin
datarootdir     = $(prefix)/share
datadir         = $(datarootdir)

docsubdir       = $(PACKAGE)-$(DOS2UNIX_VERSION)
docdir          = $(datarootdir)/doc/$(docsubdir)
localedir       = $(datarootdir)/locale
mandir          = $(datarootdir)/man
man1dir         = $(mandir)/man1
manext          = .1
man1ext         = .1

ifdef ENABLE_NLS
        POT             = po/$(PACKAGE).pot
        POFILES         = $(wildcard po/??.po) $(wildcard po/??_??.po)
        MOFILES         = $(patsubst %.po,%.mo,$(POFILES))
        NLSSUFFIX       = -nls
endif

HTMLEXT = htm
# English only documents.
INSTALL_OBJS_DOC = README.txt INSTALL.txt NEWS.txt ChangeLog.txt COPYING.txt TODO.txt BUGS.txt

# English manual
MANFILES_EN = man/man1/$(PACKAGE).1
TXTFILES_EN = man/man1/$(PACKAGE).txt
HTMLFILES_EN = man/man1/$(PACKAGE).$(HTMLEXT)
PSFILES_EN = man/man1/$(PACKAGE).ps
PDFFILES_EN = man/man1/$(PACKAGE).pdf

# International manuals
ifdef ENABLE_NLS
        MANPOTFILE      = po-man/dos2unix-man.pot
        MANPOFILES      = $(wildcard po-man/*.po)
        MANPODFILES     = $(patsubst po-man/%.po,man/%/man1/dos2unix.pod,$(MANPOFILES))
endif
MANFILES        = $(patsubst %.pod,%.1,$(MANPODFILES))
TXTFILES        = $(patsubst %.pod,%.txt,$(MANPODFILES))
HTMLFILES       = $(patsubst %.pod,%.$(HTMLEXT),$(MANPODFILES))
PSFILES         = $(patsubst %.pod,%.ps,$(MANPODFILES))
PDFFILES        = $(patsubst %.pod,%.pdf,$(MANPODFILES))

# On some systems (e.g. FreeBSD 4.10) GNU install is installed as `ginstall'.
INSTALL         = install
INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644

# On some systems (e.g. GNU Win32) GNU mkdir is installed as `gmkdir'.
MKDIR           = mkdir

ifdef ENABLE_NLS
        DOS2UNIX_NLSDEFS = -DENABLE_NLS -DLOCALEDIR=\"$(localedir)\" -DPACKAGE=\"$(PACKAGE)\"
endif

VERSIONSUFFIX   = -bin

# ......................................................... OS flags ...


ifndef D2U_OS
        d2u_os=$(shell uname -s)

ifeq ($(findstring CYGWIN,$(d2u_os)),CYGWIN)
        D2U_OS = cygwin
endif

ifndef D2U_OS
ifeq ($(findstring MSYS,$(d2u_os)),MSYS)
        D2U_OS = msys
endif
endif

ifndef D2U_OS
ifeq ($(findstring MINGW32,$(d2u_os)),MINGW32)
        D2U_OS = mingw32
endif
endif

ifndef D2U_OS
ifeq ($(findstring MINGW64,$(d2u_os)),MINGW64)
        D2U_OS = mingw64
endif
endif

ifndef D2U_OS
ifneq ($(DJGPP),)
        D2U_OS = msdos
endif
endif

ifndef D2U_OS
ifneq (, $(wildcard /opt/csw))
        D2U_OS = sun
endif
endif

ifndef D2U_OS
        D2U_OS=$(shell echo $(d2u_os) | tr [A-Z] [a-z])
endif

endif

ifeq (cygwin,$(D2U_OS))
ifdef ENABLE_NLS
        LIBS_EXTRA = -lintl -liconv
endif
        LDFLAGS_EXTRA = -Wl,--enable-auto-import
        EXE = .exe
        # allow non-cygwin clients which do not understand cygwin
        # symbolic links to launch applications...
        LINK = ln -f
        # but use symbolic links for man pages, since man client
        # IS a cygwin app and DOES understand symlinks.
        LINK_MAN = ln -fs
        # Cygwin packaging standard avoids version numbers on
        # documentation directories.
        docsubdir       = $(PACKAGE)
        MACHINE := $(subst -pc-cygwin,,$(shell gcc -dumpmachine))
        VERSIONSUFFIX   = -cygwin-$(MACHINE)
endif

ifeq (msys,$(D2U_OS))
        CC=gcc
        EXE = .exe
        MACHINE := $(subst -pc-msys,,$(shell gcc -dumpmachine))
# MSYS 1 does not support locales and no Unicode.
ifeq ($(shell ./test/chk_loc.sh en_US.utf8),no)
        UCS =
        VERSIONSUFFIX = -msys1-$(MACHINE)
else
        VERSIONSUFFIX = -msys2-$(MACHINE)
endif
ifdef ENABLE_NLS
        LIBS_EXTRA = -lintl -liconv
endif
endif

ifeq (mingw32,$(D2U_OS))
        CC=gcc
        prefix=c:/usr/local
        EXE = .exe
        VERSIONSUFFIX = -win32
        LINK = cp -f
        UNIFILE=1
        DIST_TARGET = dist-zip
ifdef ENABLE_NLS
        LIBS_EXTRA = -lintl -liconv
        ZIPOBJ_EXTRA = bin/libintl-8.dll bin/libiconv-2.dll
endif
ifeq ($(findstring w64-mingw32,$(shell gcc -dumpmachine)),w64-mingw32)
# Mingw-w64
        CFLAGS_COMPILER = -DD2U_COMPILER=MINGW32_W64
ifdef ENABLE_NLS
        ZIPOBJ_EXTRA += bin/libgcc_s_dw2-1.dll bin/libwinpthread-1.dll
endif
        CRT_GLOB_OBJ = /mingw32/i686-w64-mingw32/lib/CRT_glob.o
        LIBS_EXTRA += $(CRT_GLOB_OBJ)
        CFLAGS_OS=-I/mingw32/include
else
        CFLAGS_OS=-D_O_U16TEXT=0x20000
endif
endif

ifeq (mingw64,$(D2U_OS))
        CC=gcc
        prefix=c:/usr/local64
        EXE = .exe
        VERSIONSUFFIX = -win64
        LINK = cp -f
        UNIFILE=1
        DIST_TARGET = dist-zip
ifdef ENABLE_NLS
        LIBS_EXTRA = -lintl -liconv
        ZIPOBJ_EXTRA = bin/libintl-8.dll bin/libiconv-2.dll
endif
        CRT_GLOB_OBJ = /mingw64/x86_64-w64-mingw32/lib/CRT_glob.o
        LIBS_EXTRA += $(CRT_GLOB_OBJ)
        CFLAGS_OS=-I/mingw64/include
endif

ifeq (msdos,$(D2U_OS))
        prefix=c:/dos32
        EXE = .exe
        VERSIONSUFFIX = pm
        LINK_MAN = cp -f
        docsubdir = dos2unix
        UCS =
        ZIPOBJ_EXTRA = bin/cwsdpmi.exe
ifdef ENABLE_NLS
        LIBS_EXTRA = -lintl -liconv
endif
endif

ifeq (os/2,$(D2U_OS))
        prefix=c:/usr
        EXE = .exe
        VERSIONSUFFIX = -os2
        LINK_MAN = cp -f
        UCS =
        LDFLAGS_EXTRA = -Zargs-wild
        DIST_TARGET = dist-zip
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
endif

ifeq (freemint,$(D2U_OS))
        prefix=/usr
        EXE =
        VERSIONSUFFIX = -freemint
        UCS=
        ENABLE_NLS=
ifdef ENABLE_NLS
        LIBS_EXTRA += -lintl -liconv
endif
        EXTRA_DEFS += -Dfreemint -D__OS=\"freemint\"
endif

ifeq (freebsd,$(D2U_OS))
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif

ifeq (darwin,$(D2U_OS))
ifdef ENABLE_NLS
        CFLAGS_OS     = -I/usr/local/include
        LDFLAGS_EXTRA = -L/usr/local/lib
        LIBS_EXTRA    = -lintl
endif
endif

ifeq (sun,$(D2U_OS))
        # Running under SunOS/Solaris
        LIBS_EXTRA = -lintl
endif

ifeq (hp-ux,$(D2U_OS))
        # Running under HP-UX
        EXTRA_DEFS += -Dhpux -D_HPUX_SOURCE
endif


# ............................................................ flags ...

# PostScript and PDF generation from UTF-8 manuals is not working,
# or I don't know how to do it.

CFLAGS_USER     =
ifeq ($(DEBUG), 1)
CFLAGS          ?= -O0
else
CFLAGS          ?= -O2
endif
CFLAGS          += -Wall -Wextra -Wconversion $(RPM_OPT_FLAGS) $(CPPFLAGS) $(CFLAGS_USER)

EXTRA_CFLAGS    = -DVER_REVISION=\"$(DOS2UNIX_VERSION)\" \
                  -DVER_DATE=\"$(DOS2UNIX_DATE)\" \
                  -DVER_AUTHOR=\"$(DOS2UNIX_AUTHOR)\" \
                  -DDEBUG=$(DEBUGMSG) \
                  $(CFLAGS_OS) \
                  $(CFLAGS_COMPILER)

ifeq ($(DEBUG), 1)
        EXTRA_CFLAGS += -g
endif

ifdef STATIC
        EXTRA_CFLAGS += -static
endif

ifdef UCS
        EXTRA_CFLAGS += -DD2U_UNICODE
endif
ifdef UNIFILE
        EXTRA_CFLAGS += -DD2U_UNIFILE
endif


ifdef LFS
        EXTRA_CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
endif

LDFLAGS_USER    =
LDFLAGS = $(RPM_OPT_FLAGS) $(LDFLAGS_EXTRA) $(LDFLAGS_USER)
LIBS    = $(LIBS_EXTRA)

DEFS_USER       =
DEFS            = $(EXTRA_DEFS) $(DEFS_USER)

# .......................................................... targets ...

all: $(BIN) $(MAC2UNIX_BIN) $(UNIX2DOS_BIN) $(UNIX2MAC_BIN) doc \
     mofiles man

status:
	@echo "D2U_OS       = $(D2U_OS)"
	@echo "UCS          = $(UCS)"
	@echo "CFLAGS       = $(CFLAGS)"
	@echo "EXTRA_CFLAGS = $(EXTRA_CFLAGS)"
	@echo "LDFLAGS      = $(LDFLAGS)"
	@echo "LIBS         = $(LIBS)"

common.o : common.c common.h dos2unix.h unix2dos.h version.mk
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

querycp.o : querycp.c querycp.h
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

dos2unix.o : dos2unix.c dos2unix.h querycp.h common.h
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

unix2dos.o : unix2dos.c unix2dos.h querycp.h common.h
	$(CC) $(DEFS) $(EXTRA_CFLAGS) $(DOS2UNIX_NLSDEFS) $(CFLAGS) -c $< -o $@

$(BIN): dos2unix.o querycp.o common.o
	$(CC) $+ $(LDFLAGS) $(LIBS) -o $@

$(UNIX2DOS_BIN): unix2dos.o querycp.o common.o
	$(CC) $+ $(LDFLAGS) $(LIBS) -o $@

# DJGPP supports linking of .EXEs via 'stubify'.
# See djgpp.mak and http://www.delorie.com/djgpp/v2faq/faq22_5.html
# ln -s does automatic stubify in DJGPP 2.03.
# This changed in DJGPP 2.05. DJGPP 2.05 emulates symbolic links.

$(MAC2UNIX_BIN) : $(BIN)
ifneq ($(DJGPP),)
	stubify -g $@ ; stubedit $@ runfile=$<
else
	$(LINK) $< $@
endif


$(UNIX2MAC_BIN) : $(UNIX2DOS_BIN)
ifneq ($(DJGPP),)
	stubify -g $@ ; stubedit $@ runfile=$<
else
	$(LINK) $< $@
endif

$(MANPOTFILE) : man/man1/dos2unix.pod
	$(MAKE) -C man/man1 ../../po-man/$(notdir $@)

#  WARNING: Backward-incompatibility since GNU make 3.82.
#  The pattern-specific variables and pattern rules are now applied in the
#  shortest stem first order instead of the definition order (variables
#  and rules with the same stem length are still applied in the definition
#  order).
#  In order to stay compatible with GNU make < 3.82 we put the rule with
#  the shortest stem first.

po/%.po : $(POT)
	msgmerge --no-wrap -U $@ $(POT) --backup=numbered
	# change timestamp in case .po file was not updated.
	touch $@

%.po : man/man1/dos2unix.pod
	$(MAKE) -C man/man1 $(subst po-man/,../../po-man/,$@)

=== test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-TESTS = ascii.t iso.t utf8.t misc.t
+TESTS = ascii.t iso.t misc.t bom.t
 
 d2u_os=$(shell uname -s)
 UCS = 1
@@ -6,12 +6,12 @@
 # Checking WIN32 version in MSYS shell.
 ifeq ($(findstring MINGW,$(d2u_os)),MINGW)
 TESTS += gb18030.t
-endif
-
+else
 ifneq ($(findstring FreeBSD,$(d2u_os)),FreeBSD)
 # Unix/Linux/Cygwin. Check if zh_CN.gb18030 locale is supported.
 ifeq ($(shell ./chk_loc.sh zh_CN.gb18030),yes)
 TESTS += gb18030.t
+endif
 endif
 endif
 
@@ -23,38 +23,68 @@
 endif
 
 ifeq ($(UCS),1)
-TESTS +=utf16.t
+
+# Check for UTF-8 locale. Try C.UTF-8 and en_US.UTF-8.
+ifeq ($(shell ./chk_loc.sh C.UTF-8),yes)
+TESTS += utf16.t
+export D2U_UTF8_LOCALE = C.UTF-8
+else
+ifeq ($(shell ./chk_loc.sh en_US.UTF-8),yes)
+TESTS += utf16.t
+export D2U_UTF8_LOCALE = en_US.UTF-8
+endif
 endif
 
+# Checking WIN32 version in MSYS shell.
+ifeq ($(findstring MINGW,$(d2u_os)),MINGW)
+TESTS += utf16_gb.t
+else
+ifneq ($(findstring FreeBSD,$(d2u_os)),FreeBSD)
+# Unix/Linux/Cygwin. Check if zh_CN.gb18030 locale is supported.
+ifeq ($(shell ./chk_loc.sh zh_CN.gb18030),yes)
+TESTS += utf16_gb.t
+endif
+endif
+endif
+
+endif
+
+ifndef DJGPP
+PROVE_OPT ?= --nocolor
+endif
 
 all: test
 
 check: test
 
 test:
-	prove -v $(TESTS)
+	prove -v $(PROVE_OPT) $(TESTS)
 
 
 ascii:
-	prove -v $@.t
+	prove -v $(PROVE_OPT) $@.t
 
 iso:
-	prove -v $@.t
+	prove -v $(PROVE_OPT) $@.t
 
 misc:
-	prove -v $@.t
+	prove -v $(PROVE_OPT) $@.t
 
-utf8:
-	prove -v $@.t
+bom:
+	prove -v $(PROVE_OPT) $@.t
 
 utf16:
-	prove -v $@.t
+	@echo "D2U_UTF8_LOCALE=$(D2U_UTF8_LOCALE)"
+	prove -v $(PROVE_OPT) $@.t
 
 gb18030:
-	prove -v $@.t
+	prove -v $(PROVE_OPT) $@.t
+
+utf16_gb:
+	prove -v $(PROVE_OPT) $@.t
 
 symlink:
-	prove -v $@.t
+	prove -v $(PROVE_OPT) $@.t
 
 wcstombs:
 	$(CC) -Wall -Wextra wcstombs_test.c -o wcstombs_test

=== debian/changelog ===
dos2unix (7.4.0-1) unstable; urgency=medium

  * New upstream version 7.4.0
  * Update Vcs fields for migration from Alioth -> Salsa
  * Migrate upstream-signing-key.pgp -> debian/upstream/signing-key.asc
  * Change Section: from extra -> optional
  * Use debhelper 11
  * Bump Standards-Version to 4.1.4
  * Drop Conflicts with ancient version of tofrodos (older than o-o-stable)
  * Freshen debian/copyright dates

 -- tony mancill <tmancill@debian.org>  Sun, 22 Apr 2018 15:15:35 -0700

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: dos2unix
 Section: text
-Priority: extra
+Priority: optional
 Maintainer: Jari Aalto <jari.aalto@cante.net>
 Uploaders: tony mancill <tmancill@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 9), po4a, locales-all
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/dos2unix.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/dos2unix.git
+Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 11), po4a, locales-all
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/debian/dos2unix
+Vcs-Git: https://salsa.debian.org/debian/dos2unix.git
 Homepage: https://waterlan.home.xs4all.nl/dos2unix.html
 
 Package: dos2unix
-Conflicts: tofrodos (<< 1.7.8.debian.1)
 Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
http://www.xs4all.nl/~waterlan/dos2unix.html .*dos2unix-([.\d]+)\.tar\.gz

## dos2unix 7.4.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Author: Erwin Waterlander
 #
-#   Copyright (C) 2009-2017 Erwin Waterlander
+#   Copyright (C) 2009-2018 Erwin Waterlander
 #   All rights reserved.
 #
 #   Redistribution and use in source and binary forms, with or without
@@ -358,7 +358,7 @@
 endif
 
 LDFLAGS_USER    =
-LDFLAGS = $(RPM_OPT_FLAGS) $(LDFLAGS_EXTRA) $(LDFLAGS_USER)
+LDFLAGS = $(RPM_LD_FLAGS) $(LDFLAGS_EXTRA) $(LDFLAGS_USER)
 LIBS    = $(LIBS_EXTRA)
 
 DEFS_USER       =

=== debian/changelog ===
dos2unix (7.4.1-1) unstable; urgency=medium

  * New upstream version 7.4.1
  * Bump Standards-Version to 4.5.0
  * Use debhelper-compat 13
  * Set Rules-Requires-Root: no in debian/control

 -- tony mancill <tmancill@debian.org>  Sun, 05 Jul 2020 21:36:35 -0700

dos2unix (7.4.0-2) unstable; urgency=medium

  * Freshen packaging
  * Use https URL for debian/watch
  * Use SOURCE_DATE_EPOCH for POD date
  * Bump Standards-Version to 4.4.0

 -- tony mancill <tmancill@debian.org>  Sat, 13 Jul 2019 20:39:09 -0700

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Jari Aalto <jari.aalto@cante.net>
 Uploaders: tony mancill <tmancill@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.2), debhelper (>= 11), po4a, locales-all
-Standards-Version: 4.1.4
+Build-Depends: dpkg-dev (>= 1.16.2), debhelper-compat (= 13), po4a, locales-all
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/dos2unix
 Vcs-Git: https://salsa.debian.org/debian/dos2unix.git
 Homepage: https://waterlan.home.xs4all.nl/dos2unix.html
+Rules-Requires-Root: no
 
 Package: dos2unix
 Architecture: any
